import random
import sys
from typing import Callable, Tuple

from PyQt6 import QtWidgets


# TODO: No Param            AsyncGetterWidget
#       Single Param:       GetterWithParamWidget, AsyncGetterWithParamWidget
#       Multiple Params:    GetterWithParamsWidget, AsyncGetterWithParamsWidget

class GetterWidget(QtWidgets.QWidget):

    def __init__(self, name: str, endpoint: Callable, button_pos: Tuple[int, int] = (0, 0),
                 text_pos: Tuple[int, int] = (1, 0), execute_func: Callable = None, *args, **kwargs):
        """

        :param name: the name of the Widget
        :param endpoint: a Callable function for either the Endpoint
        :param button_pos: (optional)
        :param text_pos: (optional)
        :param execute_func: (optional) a custom function for the button press
        :param args: (optional)
        :param kwargs: (optional)
        """
        super().__init__(*args, **kwargs)
        self.layout = QtWidgets.QGridLayout()
        self.setLayout(self.layout)
        self.name = name
        self._endpoint = endpoint

        self.button = QtWidgets.QPushButton(name)
        # self.input_field = QtWidgets.QLineEdit
        self.echo_label = QtWidgets.QLabel('None')

        # noinspection PyUnresolvedReferences
        # self.textbox.textChanged.connect(self.textbox_text_changed)
        self.button.clicked.connect(self.__execute if execute_func is None else execute_func)

        self.layout.addWidget(self.button, button_pos[0], button_pos[1])
        self.layout.addWidget(self.echo_label, text_pos[0], text_pos[1])

    def __change_text(self, value):
        self.echo_label.setText(f"{self.name}: {value}")

    def __execute(self):
        value = self._endpoint()
        self.__change_text(value)

